<!--
  ~ Copyright (c) 2024 LOBA
  ~ 
  ~ Permission is hereby granted, free of charge, to any person obtaining a copy of
  ~ this software and associated documentation files (the "Software"), to deal in
  ~ the Software without restriction, including without limitation the rights to
  ~ use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of
  ~ the Software, and to permit persons to whom the Software is furnished to do so,
  ~ subject to the following conditions:
  ~ 
  ~ The above copyright notice and this permission notice shall be included in all
  ~ copies or substantial portions of the Software.
  ~ 
  ~ THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  ~ IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS
  ~ FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
  ~ COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER
  ~ IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
  ~ CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
  ~ 
  ~ SPDX-License-Identifier: MIT
  ~ 
  ~ Contributors:
  ~     [name] - [contribution]
-->

<template>
    <NuxtLayout name="default">
        <div class="catalog-page">

            <!-- sidebar navigation teleported to template -->
            <SidebarNav :nav="navItems" :title="'Catalog'" />

            <!-- <FiltersTop :sortOptions="sortOptions">
                <a href="#" class="button button-default button-black rounded" title="Add"
                    @click="showCreateDatasetModal = true">
                    <i class="icon-add"></i> Add Dataset
                </a>
                <div class="filters-top-totals"><b>33 Domains</b> related to this dataset</div>
            </FiltersTop> -->

            <Datatable :data="data" @open-edit-modal="handleOpenEditModal" @refreshData="fetchDataset">
                <template v-slot:default>
                    <button class="button-secondary orange" @click="showCreateDatasetModal = true">
                        New Dataset
                    </button>
                    <div class="filters-top-totals"><b>{{ catalogLength > 0 ? catalogLength : '' }} Datasets</b> available</div>
                </template>
            </Datatable>

        </div>
 
        <ClientOnly>
            <Teleport to="#modals-container">
                <ModalsCreateDataset v-if="showCreateDatasetModal" :id="selectedRow ? selectedRow : ''" @toggle="close" :isEditMode="isEditMode" @refresh-data="fetchDataset" />
            </Teleport>
        </ClientOnly>

        <div class="offset-xl-1 col-xl-10">
            <BannersBannerCta :banners="BannerCta" />
        </div>

    </NuxtLayout>
</template>
<script setup lang="ts">
import type DataTableI from '~/interfaces/datatable';
import type NavItemI from '~/interfaces/navItem';
import slide1 from '@/assets/images/slide1.png';
import type sliderItemI from '~/interfaces/sliderItem';
import { formatDate } from '~/utils/utils';
import { storeToRefs } from 'pinia';
import { useDataStore } from '@/stores/dataStore';

    interface Dataset {
        id: number;
        name: string;
        type: string;
        platform: string;
        domain: string;
        quality: number;
        owner: number;
    }

    interface DatasetDetails {
        domains: any;
        description: string;
        terms: any;
        owner: string;
        ownerName: string;
        createdAt: string;
        updatedAt: string;
    }

    /** Datasets - fetch from API **/

    const selectedRow = ref(null);
    const isEditMode = ref(false);
    const catalogLength = ref(0);

    const route = useRoute();
    const dataStore = useDataStore();
    const { refreshKey } = storeToRefs(dataStore); 

const fetchDataset = () => {
    useFetchAuth('/search', {
        method: 'POST',
        body: { type: 'CATALOG', limit: 25, offset: 0 }
    })
    .then(async(response: any) => {
        const datasets: Dataset[] = response;

        catalogLength.value = datasets.length;

        // Map the response data to match the structure of `rows`
        const rows = datasets?.map((dataset: Dataset, index: number) => ({
            id: dataset.id,
            name: dataset.name,
            type: dataset.type,
            platform: 'AWS S3',
            domain: dataset.domain,
            quality: 97,
            edited_at: '',
            actions: ''
        }));

        const detailedRows = await Promise.all(
            datasets.map(async (dataset: Dataset) => {
                try {
                const details = await useFetchAuth(`/catalogs/${dataset.id}`) as DatasetDetails;
                
                return {
                    id: dataset?.id,
                    name: dataset?.name,
                    type: dataset?.type,
                    platform: 'AWS S3',
                    domain: details?.domains?.map((domain: { name: string }) => domain.name).join(", "),
                    quality: 97,
                    owner: details?.owner,
                    ownerName: details?.ownerName,
                    edited_at: formatDate(details?.updatedAt),
                    created_at: formatDate(details?.createdAt),
                    actions: '',
                    description: details?.description,
                    terms: details?.terms,
                    
                };
                } catch (error) {
                    console.error(`Failed to fetch details for dataset ${dataset.id}:`, error);
                    return {
                        id: dataset?.id,
                        name: dataset?.name,
                        type: dataset?.type,
                        platform: 'AWS S3',
                        domain: '',
                        quality: 97,
                        owner: '',
                        ownerName: '',
                        edited_at: '',
                        created_at: '',
                        actions: '',
                        description: '',
                        terms: '',
                    };
                }
            })
        );

        // Update the rows in `data`
        data.value.rows = detailedRows;
    })
    .catch(error => {
        console.error('API Error:', error);
    });
}

onBeforeMount(() => {
    fetchDataset();
});

watch(refreshKey, (newKey) => {
	console.log('refreshKey', newKey);
	fetchDataset();
});

useHead({
    title: 'Catalog - DATAMITE'
});

const showCreateDatasetModal = ref(false);

const handleOpenEditModal = (row: any) => {
    selectedRow.value = row?.id; // Pass the selected row data to the modal
    isEditMode.value = true;
    showCreateDatasetModal.value = true; // Open the Edit Dataset modal
};


const close = () => {
    showCreateDatasetModal.value = false;
    isEditMode.value = false;
    fetchDataset();
};

// make the function close available to emit in other components
defineExpose({ close });

const data = ref<DataTableI>({
    options: {
        tableName: 'catalog-table',
        detailsPath: '/catalog/',
        allowCheckRow: true,
        favourites: true,
        previewComponent: 'CatalogDetails',
    },
    columns: [
        {
            id: 1,
            name: 'name',
            label: 'Name',
            filterType: 'text',
            width: '300px',
            combineColumn: 'type',
            renderComponent: 'TableColumnsName'
        },
        {
            id: 2,
            name: 'platform',
            label: 'Platform',
            filterType: 'select',
            width: '100px',
            searchable: true,
            searchableType: 'list'
        },
        {
            id: 3,
            name: 'domain',
            label: 'Domain',
            filterType: 'select',
            width: '140px',
            searchable: true,
            searchableType: 'list'
        },
        {
            id: 4,
            name: 'quality',
            label: 'Quality',
            width: '100px',
            renderComponent: 'TableColumnsQuality'
        },
        {
            id: 5,
            name: 'owner',
            label: 'Owner',
            filterType: 'select',
            width: '200px',
            renderComponent: 'UserProfile'
        },
        {
            id: 6,
            name: 'edited_at',
            label: 'Edited at',
            width: '70px'
        },
        {
            id: 7,
            name: 'actions',
            label: 'Actions',
            width: '80px',
            hideLabel: true
        }
    ],
    rows: []
});

const viewDefault = () => {
    console.log('show default home page');
}

const dummyClick = () => {
    console.log('dummyClick');
}

const navItems = ref<NavItemI[]>([
    {
        label: 'All',
        icon: 'list',
        action: viewDefault
    },
    {
        label: 'Combine Datasets',
        icon: 'chrome',
        action: dummyClick
    },
    {
        label: 'Recently Viewed',
        icon: 'clock',
        action: dummyClick
    },
    {
        label: 'Highlighted',
        icon: 'favourite',
        action: dummyClick
    },
    {
        label: 'Your Catalog',
        icon: 'loading',
        action: dummyClick
    }
]);

// const sortOptions = ref(['Last modified first', 'Last modified last', 'Option 3']);

const BannerCta = ref<sliderItemI[]>([
    {
        id: 1,
        title: 'Have a question or doubts?',
        text: 'Check our FAQs and Documentation',
        button_text: 'Faqs and Documentation',
        button_link: 'https://www.google.com',
        media_type: 1,
        media_url: slide1,
        template: 1,
    }
])

console.log(1, data.value);

</script>